diff --git a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRule.java b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRule.java
index d43112870..2f6d3f82e 100644
--- a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRule.java
+++ b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRule.java
@@ -9,7 +9,7 @@ public abstract class GameRule<T>
     private final @NotNull String translationKey;
     private final T defaultValue;
 
-    public GameRule(final @NotNull String key, final @NotNull String translationKey, final T defaultValue)
+    public GameRule(final @NotNull String key, final @NotNull String translationKey, final @NotNull T defaultValue)
     {
         this.key = key;
         this.translationKey = translationKey;
@@ -25,7 +25,7 @@ public abstract class GameRule<T>
         return this.translationKey;
     }
 
-    public T getDefaultValue()
+    public @NotNull T getDefaultValue()
     {
         return this.defaultValue;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleCollection.java b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleCollection.java
index 96b4ea68b..defc46d2a 100644
--- a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleCollection.java
+++ b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleCollection.java
@@ -2,6 +2,7 @@ package net.minecraft.core.data.gamerule;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.data.registry.Registries;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.HashMap;
 import java.util.Map;
@@ -18,7 +19,7 @@ public final class GameRuleCollection
         }
     }
 
-    public <T> T getValue(GameRule<T> gameRule)
+    public <T> @NotNull T getValue(final @NotNull GameRule<T> gameRule)
     {
         Object o = gameRules.get(gameRule);
         if (o == null)
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
index 1c1cb3b3e..73764f68c 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
@@ -753,7 +753,7 @@ public class MobWolf
                 }
                 if(!world.isClientSide)
                 {
-                    if(random.nextInt(3) == 0)
+                    if(random.nextInt(3) == 0 || !player.getGamemode().consumeBlocks())
                     {
                         setWolfTamed(true);
                         setPathToEntity(null);
diff --git a/game/core/src/main/java/net/minecraft/core/item/IItemConvertible.java b/game/core/src/main/java/net/minecraft/core/item/IItemConvertible.java
index a8dd41b9a..38e44b9f5 100644
--- a/game/core/src/main/java/net/minecraft/core/item/IItemConvertible.java
+++ b/game/core/src/main/java/net/minecraft/core/item/IItemConvertible.java
@@ -1,7 +1,9 @@
 package net.minecraft.core.item;
 
+import org.jetbrains.annotations.NotNull;
+
 public interface IItemConvertible {
     Item asItem();
 
-    ItemStack getDefaultStack();
+    @NotNull ItemStack getDefaultStack();
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/Item.java b/game/core/src/main/java/net/minecraft/core/item/Item.java
index 695cd14de..2888c293c 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Item.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Item.java
@@ -338,7 +338,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
     }
 
     @Override
-    public ItemStack getDefaultStack() {
+    public @NotNull ItemStack getDefaultStack() {
         return new ItemStack(this);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
index aa488e2c1..13757c6e0 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
@@ -1,7 +1,11 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicDoor;
 import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Direction;
@@ -13,10 +17,10 @@ import org.jetbrains.annotations.Nullable;
 import java.util.Random;
 
 public class ItemDoor extends Item {
-	protected final Block<?> doorBlockBottom;
-	protected final Block<?> doorBlockTop;
+	protected final Block<? extends BlockLogicDoor> doorBlockBottom;
+	protected final Block<? extends BlockLogicDoor> doorBlockTop;
 
-	public ItemDoor(String name, String namespaceId, int id, Block<?> doorBlockBottom, Block<?> doorBlockTop) {
+	public ItemDoor(String name, String namespaceId, int id, Block<? extends BlockLogicDoor> doorBlockBottom, Block<? extends BlockLogicDoor> doorBlockTop) {
 		super(name, namespaceId, id);
 		maxStackSize = 64;
         this.doorBlockBottom = doorBlockBottom;
@@ -30,31 +34,31 @@ public class ItemDoor extends Item {
 			blockY += side.getOffsetY();
 			blockZ += side.getOffsetZ();
 		}
-		if(!doorBlockBottom.canPlaceBlockAt(world, blockX, blockY, blockZ)) {
-			return false;
-		}
 
 		Direction dir = player.getHorizontalPlacementDirection(side).rotate(3);
 		int meta = dir.getHorizontalIndex();
-		
-		int xOffset = -dir.getOffsetX();
-		int zOffset = -dir.getOffsetZ();
 
-		int isSolidBlockLeft = (world.isBlockNormalCube(blockX - xOffset, blockY, blockZ - zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX - xOffset, blockY + 1, blockZ - zOffset) ? 1 : 0);
-		int isSolidBlockRight = (world.isBlockNormalCube(blockX + xOffset, blockY, blockZ + zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX + xOffset, blockY + 1, blockZ + zOffset) ? 1 : 0);
-		boolean isDoorLeft = world.getBlockId(blockX - xOffset, blockY, blockZ - zOffset) == doorBlockBottom.id() || world.getBlockId(blockX - xOffset, blockY + 1, blockZ - zOffset) == doorBlockTop.id();
-		boolean isDoorRight = world.getBlockId(blockX + xOffset, blockY, blockZ + zOffset) == doorBlockBottom.id() || world.getBlockId(blockX + xOffset, blockY + 1, blockZ + zOffset) == doorBlockTop.id();
+		int isSolidBlockLeft = (isSupported(world, blockX, blockY, blockZ, dir, false) ? 1 : 0) + (isSupported(world, blockX, blockY + 1, blockZ, dir, false) ? 1 : 0);
+		int isSolidBlockRight = (isSupported(world, blockX, blockY, blockZ, dir.getOpposite(), true) ? 1 : 0) + (isSupported(world, blockX, blockY + 1, blockZ, dir.getOpposite(), true) ? 1 : 0);
+		boolean isDoorLeft = world.getBlockId(blockX + dir.getOffsetX(), blockY, blockZ + dir.getOffsetZ()) == doorBlockBottom.id() || world.getBlockId(blockX + dir.getOffsetX(), blockY + 1, blockZ + dir.getOffsetZ()) == doorBlockTop.id();
+		boolean isDoorRight = world.getBlockId(blockX - dir.getOffsetX(), blockY, blockZ - dir.getOffsetZ()) == doorBlockBottom.id() || world.getBlockId(blockX - dir.getOffsetX(), blockY + 1, blockZ - dir.getOffsetZ()) == doorBlockTop.id();
 		boolean isMirrored = false;
 		
 		if(isDoorLeft && !isDoorRight) {
+			isMirrored = (world.getBlockMetadata(blockX + dir.getOffsetX(), blockY, blockZ + dir.getOffsetZ()) & BlockLogicDoor.MASK_HINGE) == 0;
+		} else if (isSolidBlockLeft > 0 && side.getDirection() == dir.getOpposite()) {
+		} else if (isSolidBlockRight > 0 && side.getDirection() == dir) {
 			isMirrored = true;
 		} else if(isSolidBlockRight > isSolidBlockLeft) {
 			isMirrored = true;
 		}
 		if(isMirrored) {
-			meta = meta - 1 & 3;
-			meta += 4;
-			meta |= 0x8;
+			meta = meta - 1 & 0b11;
+			meta |= 0b100;
+			meta |= 0b1000;
+		}
+		if(!doorBlockBottom.getLogic().canPlaceBlockAt(world, blockX, blockY, blockZ, meta)) {
+			return false;
 		}
 		
 		world.noNeighborUpdate = true;
@@ -70,6 +74,11 @@ public class ItemDoor extends Item {
 		return true;
 	}
 
+	public boolean isSupported(@NotNull World world, int x, int y, int z, @NotNull Direction direction, boolean mirrored) {
+		ISupport support = world.getSupport(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ(), direction.getSide().getOpposite());
+		return support.canSupport(mirrored ? PartialSupport.INSTANCE.right() : PartialSupport.INSTANCE.left(), direction.getSide());
+	}
+
 	@Override
 	public void onUseByActivator(ItemStack itemStack, TileEntityActivator activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
 		if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
@@ -77,32 +86,29 @@ public class ItemDoor extends Item {
 			blockY += direction.getOffsetY();
 			blockZ += direction.getOffsetZ();
 		}
-		if(!doorBlockBottom.canPlaceBlockAt(world, blockX, blockY, blockZ)) {
-			return;
-		}
 
 		if (!direction.isHorizontal()) direction = Direction.NORTH;
 		Direction dir = direction.rotate(3);
 		int meta = dir.getHorizontalIndex();
 
-		int xOffset = -dir.getOffsetX();
-		int zOffset = -dir.getOffsetZ();
-
-		int isSolidBlockLeft = (world.isBlockNormalCube(blockX - xOffset, blockY, blockZ - zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX - xOffset, blockY + 1, blockZ - zOffset) ? 1 : 0);
-		int isSolidBlockRight = (world.isBlockNormalCube(blockX + xOffset, blockY, blockZ + zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX + xOffset, blockY + 1, blockZ + zOffset) ? 1 : 0);
-		boolean isDoorLeft = world.getBlockId(blockX - xOffset, blockY, blockZ - zOffset) == doorBlockBottom.id() || world.getBlockId(blockX - xOffset, blockY + 1, blockZ - zOffset) == doorBlockTop.id();
-		boolean isDoorRight = world.getBlockId(blockX + xOffset, blockY, blockZ + zOffset) == doorBlockBottom.id() || world.getBlockId(blockX + xOffset, blockY + 1, blockZ + zOffset) == doorBlockTop.id();
+		int isSolidBlockLeft = (world.isBlockNormalCube(blockX + dir.getOffsetX(), blockY, blockZ + dir.getOffsetZ()) ? 1 : 0) + (world.isBlockNormalCube(blockX + dir.getOffsetX(), blockY + 1, blockZ + dir.getOffsetZ()) ? 1 : 0);
+		int isSolidBlockRight = (world.isBlockNormalCube(blockX - dir.getOffsetX(), blockY, blockZ - dir.getOffsetZ()) ? 1 : 0) + (world.isBlockNormalCube(blockX - dir.getOffsetX(), blockY + 1, blockZ - dir.getOffsetZ()) ? 1 : 0);
+		boolean isDoorLeft = world.getBlockId(blockX + dir.getOffsetX(), blockY, blockZ + dir.getOffsetZ()) == doorBlockBottom.id() || world.getBlockId(blockX + dir.getOffsetX(), blockY + 1, blockZ + dir.getOffsetZ()) == doorBlockTop.id();
+		boolean isDoorRight = world.getBlockId(blockX - dir.getOffsetX(), blockY, blockZ - dir.getOffsetZ()) == doorBlockBottom.id() || world.getBlockId(blockX - dir.getOffsetX(), blockY + 1, blockZ - dir.getOffsetZ()) == doorBlockTop.id();
 		boolean isMirrored = false;
 
 		if(isDoorLeft && !isDoorRight) {
-			isMirrored = true;
+			isMirrored = (world.getBlockMetadata(blockX + dir.getOffsetX(), blockY, blockZ + dir.getOffsetZ()) & BlockLogicDoor.MASK_HINGE) == 0;
 		} else if(isSolidBlockRight > isSolidBlockLeft) {
 			isMirrored = true;
 		}
 		if(isMirrored) {
-			meta = meta - 1 & 3;
-			meta += 4;
-			meta |= 0x8;
+			meta = meta - 1 & 0b11;
+			meta |= 0b100;
+			meta |= 0b1000;
+		}
+		if(!doorBlockBottom.getLogic().canPlaceBlockAt(world, blockX, blockY, blockZ, meta)) {
+			return;
 		}
 
 		world.noNeighborUpdate = true;
@@ -116,4 +122,5 @@ public class ItemDoor extends Item {
 		doorBlockTop.onBlockPlacedOnSide(world, blockX, blockY + 1, blockZ, direction.getSide(), 0.5, 0.5);
 		itemStack.consumeItem(null);
 	}
+
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java b/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
index d950b8f5f..6eed035e1 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicDoor;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Direction;
@@ -11,7 +12,7 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class ItemDoorPainted extends ItemDoor {
-    public ItemDoorPainted(String name, String namespaceId, int id, Block<?> doorBottom, Block<?> doorTopId) {
+    public ItemDoorPainted(String name, String namespaceId, int id, Block<? extends BlockLogicDoor> doorBottom, Block<? extends BlockLogicDoor> doorTopId) {
         super(name, namespaceId, id, doorBottom, doorTopId);
     }
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/util/Util.java b/game/core/src/main/java/net/minecraft/core/util/Util.java
new file mode 100644
index 000000000..20df90c85
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/util/Util.java
@@ -0,0 +1,14 @@
+package net.minecraft.core.util;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public final class Util {
+    public static @NotNull String emptyStringIfNull(final @Nullable String string) {
+        if (string == null) {
+            return "";
+        }
+
+        return string;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/Side.java b/game/core/src/main/java/net/minecraft/core/util/helper/Side.java
index a2c1faf97..cc33de425 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/Side.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/Side.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.util.helper;
 
+import org.jetbrains.annotations.NotNull;
+
 public enum Side {
 	
 	TOP(Axis.Y, 0, 1, 0, "top"),
@@ -95,7 +97,7 @@ public enum Side {
 		return offsetZ;
 	}
 	
-	public Side getOpposite() {
+	public @NotNull Side getOpposite() {
 		return opposite;
 	}
 	
diff --git a/game/core/src/main/java/net/minecraft/core/world/Dimension.java b/game/core/src/main/java/net/minecraft/core/world/Dimension.java
index 85db03fd9..7df0f373a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/Dimension.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Dimension.java
@@ -10,6 +10,7 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Collections;
@@ -85,7 +86,7 @@ public class Dimension
 	public static final Dimension NETHER = new Dimension("nether", OVERWORLD, 0.125f, Blocks.PORTAL_NETHER, WorldTypes.NETHER_DEFAULT);
 	public static final Dimension DRIFT = new Dimension("drift", OVERWORLD, 8.0f, Blocks.PORTAL_DRIFT, WorldTypes.DRIFT_DEFAULT);
 
-	public static Int2ObjectMap<Dimension> getDimensionList() {
+	public static @NotNull Int2ObjectMap<Dimension> getDimensionList() {
 		return dimensionListUnmodifiable;
 	}
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 6e39f17b4..781685bde 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -14,6 +14,9 @@ import java.util.UUID;
 import com.mojang.logging.LogUtils;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.ISupportable;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.current.wire.WireHandler;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
@@ -1661,7 +1664,7 @@ public class World implements WorldSource {
                 int id1 = getBlockId(entry.x, entry.y, entry.z);
                 if(id1 == entry.blockId && id1 > 0) {
                     immediatelyUpdatedPositions.add(entry);
-                    Blocks.blocksList[id1].updateTick(this, entry.x, entry.y, entry.z, rand);
+                    Blocks.blocksList[id1].updateTick(this, entry.x, entry.y, entry.z, rand, false);
                 }
             }
             return;
@@ -2229,6 +2232,12 @@ public class World implements WorldSource {
         }
     }
 
+    public @NotNull ISupport getSupport(int x, int y, int z, @NotNull Side side) {
+        Block<?> b = getBlock(x, y, z);
+        if (b == null) return PartialSupport.INSTANCE;
+        return b.getSupport(this, x, y, z, side);
+    }
+
     @Override
     public boolean isBlockNormalCube(int x, int y, int z)
     {
@@ -2445,7 +2454,7 @@ public class World implements WorldSource {
                     int iBlockY = (iRandVal / (ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X)) & (ChunkSection.SECTION_SIZE_Y - 1) + s * ChunkSection.SECTION_SIZE_Y;
                     int id = chunk.getBlockID(iBlockX, iBlockY, iBlockZ);
                     if (Blocks.shouldTick[id]) {
-                        Blocks.blocksList[id].updateTick(this, iBlockX + chunkBlockX, iBlockY, iBlockZ + chunkBlockZ, this.rand);
+                        Blocks.blocksList[id].updateTick(this, iBlockX + chunkBlockX, iBlockY, iBlockZ + chunkBlockZ, this.rand, true);
                     }
                 }
             }
@@ -2481,7 +2490,7 @@ public class World implements WorldSource {
             int blockId = getBlockId(entry.x, entry.y, entry.z);
             if(blockId == entry.blockId && blockId > 0)
             {
-                Blocks.blocksList[blockId].updateTick(this, entry.x, entry.y, entry.z, rand);
+                Blocks.blocksList[blockId].updateTick(this, entry.x, entry.y, entry.z, rand, false);
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfig.java b/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfig.java
index 11ac99e7e..edc813b88 100644
--- a/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfig.java
+++ b/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfig.java
@@ -1,8 +1,10 @@
 package net.minecraft.core.world.config.season;
 
+import org.jetbrains.annotations.NotNull;
+
 public abstract class SeasonConfig
 {
-    public static SeasonConfigBuilder builder()
+    public static @NotNull SeasonConfigBuilder builder()
     {
         return new SeasonConfigBuilder();
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigBuilder.java b/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigBuilder.java
index 951626226..89f9ff7b4 100644
--- a/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigBuilder.java
+++ b/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigBuilder.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.config.season;
 import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.core.world.season.Season;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -22,7 +23,7 @@ public class SeasonConfigBuilder
 
     protected SeasonConfigBuilder() { }
 
-    public SeasonConfig build()
+    public @NotNull SeasonConfig build()
     {
         if (this.type == Type.SINGLE && this.singleSeason != null)
         {
@@ -38,7 +39,7 @@ public class SeasonConfigBuilder
         }
     }
 
-    public SeasonConfigBuilder withSingleSeason(final Season season)
+    public @NotNull SeasonConfigBuilder withSingleSeason(final Season season)
     {
         this.type = Type.SINGLE;
         this.seasons = null;
@@ -48,7 +49,7 @@ public class SeasonConfigBuilder
         return this;
     }
 
-    public SeasonConfigBuilder withSeasonInCycle(final Season season, final int length)
+    public @NotNull SeasonConfigBuilder withSeasonInCycle(final Season season, final int length)
     {
         this.type = Type.CYCLE;
         if (this.seasons == null) this.seasons = new ArrayList<>();
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkDecoration.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkDecoration.java
new file mode 100644
index 000000000..3b87cc68b
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkDecoration.java
@@ -0,0 +1,11 @@
+package net.minecraft.core.world.generate.chunk;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public interface ChunkDecoration {
+    void placeDecoration(final @NotNull World world, final @NotNull Chunk chunk, final int worldX, final int worldZ, final int minY, final int maxY, final int rangeY, final @NotNull Random rand);
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkFeatureDecorator.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkFeatureDecorator.java
new file mode 100644
index 000000000..5f39eaa7d
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkFeatureDecorator.java
@@ -0,0 +1,73 @@
+package net.minecraft.core.world.generate.chunk;
+
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicSand;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Map;
+import java.util.Random;
+
+public abstract class ChunkFeatureDecorator
+    implements ChunkDecorator
+{
+    private boolean initialized = false;
+    private final @NotNull World world;
+    private final @NotNull Object2IntMap<ChunkDecoration> decorations = new Object2IntOpenHashMap<>();
+
+    public ChunkFeatureDecorator(final @NotNull World world) {
+        this.world = world;
+    }
+
+    /* package-private */ final void registerDecorationsSetup() {
+        if (!this.initialized) {
+            this.registerDecorations();
+            this.initialized = true;
+        }
+    }
+
+    public abstract void registerDecorations();
+
+    public final @NotNull ChunkFeatureDecorator register(final int seed, final @NotNull ChunkDecoration decoration) {
+        this.decorations.put(decoration, seed);
+
+        return this;
+    }
+
+    @Override
+    public final void decorate(final @NotNull Chunk chunk) {
+        this.world.scheduledUpdatesAreImmediate = true;
+        BlockLogicSand.fallInstantly = true;
+
+        final int chunkX = chunk.xPosition;
+        final int chunkZ = chunk.zPosition;
+        final int worldX = chunkX * 16;
+        final int worldZ = chunkZ * 16;
+
+        final int minY = this.world.getWorldType().getMinY();
+        final int maxY = this.world.getWorldType().getMaxY();
+        final int rangeY = (maxY + 1) - minY;
+
+        final @NotNull Random rand = new Random(this.world.getRandomSeed());
+        final long a = (rand.nextLong() / 2L) * 2L + 1L;
+        final long b = (rand.nextLong() / 2L) * 2L + 1L;
+
+        for (final @NotNull ChunkDecoration decoration : this.decorations.keySet()) {
+            final int decorationSeed = this.decorations.getInt(decoration);
+            rand.setSeed((long) chunkX * a + (long) chunkZ * b ^ this.world.getRandomSeed() ^ decorationSeed);
+            decoration.placeDecoration(this.world, chunk, worldX, worldZ, minY, maxY, rangeY, rand);
+        }
+
+        this.postDecorate(this.world, chunk);
+
+        BlockLogicSand.fallInstantly = false;
+        this.world.scheduledUpdatesAreImmediate = false;
+    }
+
+    public abstract void postDecorate(final @NotNull World world, final @NotNull Chunk chunk);
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGenerator.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGenerator.java
index 404380849..70e0c3e58 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGenerator.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGenerator.java
@@ -65,7 +65,6 @@ public abstract class ChunkGenerator
         ChunkGeneratorResult result = doBlockGeneration(chunk);
 
         // Slice up blocks
-        int blocksInSection = CHUNK_SIZE_X * SECTION_SIZE_Y * CHUNK_SIZE_Z;
         for (int sectionY = 0; sectionY < Chunk.CHUNK_SECTIONS; sectionY++) {
             ChunkSection section = chunk.getSection(sectionY);
             section.blocks = result.getSectionBlocks(sectionY);
@@ -83,6 +82,10 @@ public abstract class ChunkGenerator
      */
     public final void decorate(Chunk chunk)
     {
+        if (decorator instanceof ChunkFeatureDecorator) {
+            ((ChunkFeatureDecorator) decorator).registerDecorationsSetup();
+        }
+
         decorator.decorate(chunk);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index 8ccca75ff..63a25d670 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -584,6 +584,36 @@ public class ChunkDecoratorOverworld
             (new WorldFeatureLiquid(Blocks.FLUID_LAVA_FLOWING.id())).place(world, rand, i22, l23, i25);
         }
 
+        int numPebbles = 0;
+        if (biome == Biomes.OVERWORLD_FOREST) {
+            numPebbles = 2;
+        }
+        if (biome == Biomes.OVERWORLD_SWAMPLAND) {
+            numPebbles = 2;
+        }
+        if (biome == Biomes.OVERWORLD_GRASSLANDS) {
+            numPebbles = 2;
+        }
+        if (biome == Biomes.OVERWORLD_PLAINS || biome == Biomes.OVERWORLD_SHRUBLAND) {
+            numPebbles = 3;
+        }
+        if (biome == Biomes.OVERWORLD_CAATINGA || biome == Biomes.OVERWORLD_CAATINGA_PLAINS) {
+            numPebbles = 5;
+        }
+        if (biome == Biomes.OVERWORLD_OUTBACK_GRASSY || biome == Biomes.OVERWORLD_OUTBACK) {
+            numPebbles = 2;
+        }
+        if (biome == Biomes.OVERWORLD_DESERT) {
+            numPebbles = 5;
+        }
+
+        for (int i = 0; i < numPebbles; i++) {
+            final int xx = x + rand.nextInt(16) + 8;
+            final int yy = minY + rand.nextInt(rangeY);
+            final int zz = z + rand.nextInt(16) + 8;
+            (new WorldFeaturePebbles(Blocks.OVERLAY_PEBBLES.id(), 16, true)).place(this.world, rand, xx, yy, zz);
+        }
+
         int oceanY = world.getWorldType().getOceanY();
         for(int dx = x + 8; dx < x + 8 + 16; dx++)
         {
